<template src="./template.html"></template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
var momentz = require("moment-timezone");
var moment = require("moment");
//@ts-ignore
import jsonCountry from "@/locales/countryCode.json";
//@ts-ignore
import jsonProvince from "@/locales/provinceCode.json";
import _ from "lodash";
import { api } from "~/common/constaint";
@Component({
  components: {
    Loading: () => import("@/components/Utils/Loading/index.vue"),
  },
})
export default class StoreOrder extends Vue {
  storeId = "";
  config = {
    page: 1,
    limit: 25,
    search: "",
    orderCode: "",
    email: "",
    domain: "",
    priceFrom: 0,
    priceTo: 0,
  };
  totalPage = 0;
  page = 1;
  limitItems = [5, , 10, , 15, , 20, , 25, , 30, , 35, , 40];

  loadingTable = false;

  panelFilter = false;
  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = momentz().startOf("month").format("YYYY-MM-DD");
  dateEnd = momentz().endOf("day").format("YYYY-MM-DD");
  exportData = false;
  listStatus = [
    {
      name: "All",
      value: "",
    },
    {
      name: "Processing",
      value: "processing",
    },
    {
      name: "Done",
      value: "done",
    },
    {
      name: "Fulfilled",
      value: "fulfilled",
    },
    {
      name: "Canceled",
      value: "canceled",
    },
  ];
  status = "";
  listOrder = [];

  settings: any = {
    timezone: "+7",
  };

  selectedAll = false;
  listOrderId = [];

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  json_fields = {
    "Order Name": "orderName",
    Sku: "sku",
    "Product Name": "productName",
    "Variant Name": "variantName",
    Quantity: "quantity",
    "Item Status": "itemStatus",
    "Delivery Status": "deliveryStatus",
    "Last Status Updated At": "lastStatusUpdatedAt",
    "Paid At": "paidAt",
    "Processing At": "progressingAt",
    "Fulfilled At": "fulfilledAt",
    "Tracking Number": "trackingNumber",
    "Tracking Status": "trackingStatus",
    Subtotal: "subTotal",
    "Shipping Price": "shippingPrice",
    "Discount Price": "discountPrice",
    "Total Amount": "totalAmount",
    Refund: "refund",
    "Buyer Name": "buyerName",
    Email: "email",
    "Shipping Address 1": "shippingAddress1",
    "Shipping Address 2": "shippingAddress2",
    "Shipping Phone": "shippingPhone",
    "Shipping City": "shippingCity",
    "Shipping Zip": "shippingZip",
    "Shipping Province": "shippingProvince",
    "Shipping Country": "shippingCountry",
    "Shipping Country Code": "shippingCountryCode",
    "Shipping Province Code": "shippingProvinceCode",
    "Payment Gateway ID": "paymentGateWayId",
    "Gateway Name": "gatewayName",
    "Gateway Type": "gatewayType",
    Domain: "domain",
    "Transaction Id": "transactionId",
  };
  json_data: any = [];
  json_meta = [
    [
      {
        key: "charset",
        value: "utf-8",
      },
    ],
  ];

  fetchData() {
    this.json_data = [];
    for (let id of this.listOrderId) {
      const findOrder: any = this.listOrder.find(
        (order: any) => order._id === id
      );
      let listVariant;
      let listProduct;
      let listQuantity;
      let listSku;
      let listSlug;
      if (findOrder?.listSelectedProductId?.length) {
        listVariant = findOrder.listSelectedProductId
          .map((product: any) => product?.listValue)
          .join("\n");
        listProduct = findOrder.listSelectedProductId
          .map((product: any) => product?.name)
          .join("\n");
        listQuantity = findOrder.listSelectedProductId
          .map((product: any) => product?.quantity)
          .join("\n");
        listSku = findOrder.listSelectedProductId
          .map((product: any) => product?.sku)
          .join("\n");
        listSlug = findOrder.listSelectedProductId
          .map((product: any) => product?.slug)
          .join("\n");
      }

      if (findOrder && findOrder.shippingAddress) {
        let payment = "";
        if (findOrder?.paypal?.paymentID) {
          payment = "Paypal";
        } else if (findOrder?.stripe) {
          payment = "Stripe";
        }
        let itemStatus = "";
        if (findOrder.orderStatus === "processing") itemStatus = "Processing";
        else if (findOrder.orderStatus === "pending") itemStatus = "Pending";
        else if (findOrder.orderStatus === "canceled") itemStatus = "Canceled";
        else if (findOrder.orderStatus === "fulfilled")
          itemStatus = "Fulfilled";

        let deliveryStatus = "";
        if (findOrder.shippingStatus === 1) deliveryStatus = "TRACKING_PAID";
        else if (findOrder.shippingStatus === 2)
          deliveryStatus = "TRACKING_AVAILABLE";
        else if (findOrder.shippingStatus === 3)
          deliveryStatus = "TRACKING_ONLINE";
        else if (findOrder.shippingStatus === 4)
          deliveryStatus = "TRACKING_DELIVERY&GUARANTEE";

        const {
          address,
          apartment,
          city,
          companyName,
          country,
          email,
          firstName,
          lastName,
          phoneNumber,
          state,
          zipCode,
        } = findOrder.shippingAddress;
        const { listSelectedProductId } = findOrder;
        if (listSelectedProductId.length === 1) {
          //@ts-ignore
          this.json_data.push({
            orderName: findOrder.orderCode,
            sku: listSku,
            productName: listProduct || "",
            variantName: listVariant || "",
            quantity: listQuantity || "",
            itemStatus,
            deliveryStatus,
            lastStatusUpdatedAt:
              findOrder.updatedAt &&
              this.$utils.formatDateCreatedAt(findOrder.updatedAt),
            paidAt:
              findOrder.createdAt &&
              this.$utils.formatDateCreatedAt(findOrder.createdAt),
            progressingAt:
              findOrder.processingDate &&
              this.$utils.formatDateCreatedAt(findOrder.processingDate),
            fulfilledAt: findOrder.fulfilledAt || "",
            trackingNumber: findOrder.trackingNumber,
            trackingStatus: "",
            subTotal: findOrder.subTotal,
            shippingPrice: findOrder.shipping,
            discountPrice: findOrder.discount,
            totalAmount: findOrder.total,
            refund: 0,
            buyerName: `${findOrder.shippingAddress.firstName} ${findOrder.shippingAddress.lastName}`,
            email: findOrder.shippingAddress.email,
            shippingAddress1: address,
            shippingAddress2: apartment,
            shippingPhone: phoneNumber,
            shippingCity: city,
            shippingZip: zipCode,
            shippingProvince: this.findProvinceCode(state),
            shippingCountry: country,
            shippingCountryCode: this.findCountryCodeByCountry(country),
            shippingProvinceCode: state || "",
            paymentGateWayId: "",
            gatewayName: "",
            gatewayType: payment,
            domain: findOrder?.storeId?.domain || "",
            transactionId: findOrder?.paypal?.paymentID || "",
          });
        } else {
          const subTotal = _.sumBy(listSelectedProductId, "productId.price");
          for (let i = 0; i < listSelectedProductId.length; i++) {
            const product = listSelectedProductId[i];
            //@ts-ignore
            this.json_data.push({
              orderName: findOrder.orderCode,
              sku: product.sku || "",
              productName: product.domain || "",
              variantName: product.listValue.join(",") || "",
              quantity: product.quantity,
              itemStatus,
              deliveryStatus,
              lastStatusUpdatedAt:
                findOrder.updatedAt &&
                this.$utils.formatDateCreatedAt(findOrder.updatedAt),
              paidAt:
                findOrder.createdAt &&
                this.$utils.formatDateCreatedAt(findOrder.createdAt),
              progressingAt:
                findOrder.processingDate &&
                this.$utils.formatDateCreatedAt(findOrder.processingDate),
              fulfilledAt: findOrder.fulfilledAt || "",
              trackingNumber: findOrder.trackingNumber,
              trackingStatus: "",
              subTotal: i === 0 ? subTotal : 0,
              shippingPrice: i === 0 ? findOrder.shipping : 0,
              discountPrice: findOrder.discount,
              totalAmount: findOrder.total,
              refund: 0,
              buyerName: `${findOrder.shippingAddress.firstName} ${findOrder.shippingAddress.lastName}`,
              email: findOrder.shippingAddress.email,
              shippingAddress1: address,
              shippingAddress2: apartment,
              shippingPhone: phoneNumber,
              shippingCity: city,
              shippingZip: zipCode,
              shippingProvince: this.findProvinceCode(state),
              shippingCountry: country,
              shippingCountryCode: this.findCountryCodeByCountry(country),
              shippingProvinceCode: state || "",
              paymentGateWayId: "",
              gatewayName: "",
              gatewayType: payment,
              domain: listSlug,
              transactionId: findOrder?.paypal?.paymentID || "",
            });
          }
        }
      }
    }
    this.$pushNotification.success("Export successfully");
    this.exportData = false;
  }

  onExportFile() {
    if (!this.listOrderId.length) {
      return this.$pushNotification.error("Please select order list");
    }
    //@ts-ignore
    this.$refs.export.$el.click();
  }

  mounted() {
    this.$store.commit("setting/setTime", {
      dateStart: this.dateStart,
      dateEnd: this.dateEnd,
    });
    this.storeId = this.$route.params.id || "";
    if (this.storeId) {
      this.onGetListOrder();
    }
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  async onGetListOrder() {
    try {
      this.$store.commit("setting/setTime", {
        dateStart: this.dateStart,
        dateEnd: this.dateEnd,
      });
      this.loadingTable = true;
      let config: any = this.config;
      if (this.status) {
        config["orderStatus"] = this.status;
      }
      let filter = {
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      };
      const response = await this.$api.sellerOrder.list({
        ...config,
        ...filter,
        storeId: this.storeId,
      });
      if (response?.data?.data) {
        const { total } = response.data;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.listOrder = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListOrder();
  }

  openDialogDetail(order: any) {
    this.$store.commit("sellerStore/setOrderDetail", order);
    this.$store.commit("sellerStore/setDrawer", true);
  }

  resetField() {
    this.config = {
      page: 1,
      limit: 25,
      search: "",
      orderCode: "",
      email: "",
      domain: "",
      priceFrom: 0,
      priceTo: 0,
      //   storeId: "643903f4cc2c6e9262e56d50",
    };
    this.onGetListOrder();
  }

  findCountryCodeByCountry(country: string) {
    for (let item in jsonCountry) {
      if (jsonCountry[item] === country) {
        return item;
      }
    }
  }

  findProvinceCode(province: string) {
    const findProvince = jsonProvince.find(
      (item: any) => item.abbreviation === province
    );
    if (findProvince) {
      return findProvince.name;
    }
    return province;
  }

  @Watch("selectedAll")
  async onSelectAllChanged(value: string, oldValue: string) {
    if (value) {
      const listOrderId = [...this.listOrderId];
      //@ts-ignore
      const selectedCurrentOrder = this.listOrder
        //@ts-ignore
        .map((order) => order._id)
        //@ts-ignore
        .filter((id) => !listOrderId.includes(id));
      //@ts-ignore
      this.listOrderId = [...listOrderId, ...selectedCurrentOrder];
    } else {
      //@ts-ignore
      const selectedCurrentOrder = this.listOrder
        //@ts-ignore
        .map((order) => order._id);
      this.listOrderId = this.listOrderId.filter(
        (c) => !selectedCurrentOrder.includes(c)
      );
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListOrder();
  }

  @Watch("status")
  changedStatus() {
    this.listOrderId = [];
    this.selectedAll = false;
    this.resetField();
    this.onGetListOrder();
  }
}
</script>

<style lang="scss" scoped>
.check-mb-select {
  @media (max-width: 520px) {
    margin-bottom: 12px;
  }
}
</style>
